package compiler;

import java.util.Vector;

class TypeEntry {


  public CTreeNode node;
  public String name;
  public String definedType;
  public String actualType;
  public int type;
  public String arrayPart;
  public Vector arrayMins;

  public TypeEntry (CTreeNode node1) {
    CTreeNode arrayDimension, tempCTN, tempCTN1, tempCTN2;
    TypeEntry tempTE;
    int i;
    Integer lower, upper;

    node=node1;
    arrayPart=new String ("");
    if (node1==null) {
      type=Constants.TYPE_SIMPLE;
      name="X";
      definedType="X";
      actualType="void";
    } else {
      if (node.name.compareTo ("def_tipa")==0) {
        name=node.prefix+((CTreeNode)(node.children.elementAt (0))).name;
        tempCTN=(CTreeNode)(node.children.elementAt (2));
        tempCTN1=(CTreeNode)(tempCTN.children.elementAt (0));
        if ((tempCTN1.name.compareTo ("tabela")==0) && (tempCTN1.symbolNum!=sym.IME) && (tempCTN1.children.size ()>5)) {
          if (tempCTN1.children.size ()==6)
            tempCTN2=(CTreeNode)(tempCTN1.children.elementAt (2));
          else
            tempCTN2=(CTreeNode)(tempCTN1.children.elementAt (3));
          arrayMins=new Vector ();
          for (i=0; i<tempCTN2.children.size (); i+=2) {
            arrayDimension=(CTreeNode)(tempCTN2.children.elementAt (i));
            lower=new Integer (((CTreeNode)(arrayDimension.children.elementAt (0))).toString ());
            upper=new Integer (((CTreeNode)(arrayDimension.children.elementAt (2))).toString ());
            arrayMins.add (lower);
            arrayPart+="["+(upper.intValue ()-lower.intValue ()+1)+"]";
          }
          type=Constants.TYPE_ARRAY;
        } else
          type=getType (tempCTN);
        tempCTN.finalConvert ();
        tempTE=node.tree.lookupType (tempCTN, false);
        actualType=tempTE.actualType;
        if (tempTE.name.compareTo ("X")==0)
          definedType=tempCTN.toString ();
        else
          definedType=tempTE.toString ();
      }
      if (node.name.compareTo ("tip")==0) {
        tempCTN1=(CTreeNode)(node.children.elementAt (0));
        if ((tempCTN1.name.compareTo ("tabela")==0) && (tempCTN1.symbolNum!=sym.IME) && (tempCTN1.children.size ()>5)) {
          if (tempCTN1.children.size ()==6)
            tempCTN2=(CTreeNode)(tempCTN1.children.elementAt (2));
          else
            tempCTN2=(CTreeNode)(tempCTN1.children.elementAt (3));
          arrayMins=new Vector ();
          for (i=0; i<tempCTN2.children.size (); i+=2) {
            arrayDimension=(CTreeNode)(tempCTN2.children.elementAt (i));
            lower=new Integer (((CTreeNode)(arrayDimension.children.elementAt (0))).toString ());
            upper=new Integer (((CTreeNode)(arrayDimension.children.elementAt (2))).toString ());
            arrayMins.add (lower);
            arrayPart+="["+(upper.intValue ()-lower.intValue ()+1)+"]";
          }
          type=Constants.TYPE_ARRAY;
          node.finalConvert ();
          actualType=node.tree.lookupType (node, true).name;
        } else {
          type=getType (node);
          node.finalConvert ();
          actualType=node.toString ();
        }
        if (type==Constants.TYPE_ENUM) {
          name="Tenum"+node.tree.typeCount;
          node.tree.typeCount++;
        } else
          name="X";
        definedType="X";
      }
      if (node.symbolNum==sym.IME) {
        name="X";
        definedType="X";
        node.finalConvert ();
        actualType=node.toString ();
      }
    }
  }

  public static int getType (CTreeNode node) {
    CTreeNode tempCTN, tempCTN1;

    tempCTN=(CTreeNode)(node.children.elementAt (0));
    if (tempCTN.name.compareTo ("enostaven_tip")==0) {
      tempCTN1=(CTreeNode)(tempCTN.children.elementAt (0));
      if (tempCTN1.symbolNum==sym.OKLEPAJ)
        return Constants.TYPE_ENUM;
    }
    return Constants.TYPE_SIMPLE;
  }

  public String getDefinition () {
    CTreeNode tempCTN;

    if ((name.compareTo ("X")==0) || (type==Constants.TYPE_ARRAY))
      return "";
    if (type==Constants.TYPE_ENUM) {
      return "enum "+name+" "+actualType;
    }
    if (definedType.compareTo ("X")==0)
      return "typedef "+actualType+" "+name;
    else
      return "typedef "+definedType+" "+name;
  }

  public String toString () {
    if ((name.compareTo ("X")==0) || (type==Constants.TYPE_ARRAY))
      return actualType;
    else {
      if (type==Constants.TYPE_ENUM)
        return "enum "+name;
      return name;
    }
  }
}