package compiler;

public class Classify {

  public static String cKeyword, cIdentifier, cString, cNumber, cComment, cOther;

  public static boolean noSpaceLR (ParseTreeNode node) {
    int symbolNum;

    if (node==null)
      return true;
    symbolNum=node.symbolNum;
    if ((symbolNum==sym.DELJENO) || (symbolNum==sym.ENACAJ) || (symbolNum==sym.KRAT) || (symbolNum==sym.MANJSE) || (symbolNum==sym.MANJSEENAKO) || (symbolNum==sym.MINUS) || (symbolNum==sym.NEENACAJ) || (symbolNum==sym.PIKA) || (symbolNum==sym.PIKAPIKA) || (symbolNum==sym.PLUS) || (symbolNum==sym.PRIREJANJE) || (symbolNum==sym.VECJE) || (symbolNum==sym.VECJEENAKO) || (symbolNum==Constants.NODE_PP))
      return true;
    else
      return false;
  }

  public static boolean noSpaceL (ParseTreeNode node) {
    int symbolNum;

    if (node==null)
      return true;
    symbolNum=node.symbolNum;
    if ((symbolNum==sym.DVOPICJE) || (symbolNum==Constants.NODE_COLON_LABEL) || (symbolNum==sym.OGLATIZAKLEPAJ) || (symbolNum==sym.PODPICJE) || (symbolNum==sym.PUSCICA) || (symbolNum==sym.VEJICA) || (symbolNum==sym.ZAKLEPAJ))
      return true;
    else
      return false;
  }

  public static boolean noSpaceR (ParseTreeNode node) {
    int symbolNum;

    if (node==null)
      return true;
    symbolNum=node.symbolNum;
    if ((symbolNum==sym.OGLATIOKLEPAJ) || (symbolNum==sym.OKLEPAJ))
      return true;
    else
      return false;
  }

  public static boolean alwaysSpaceR (ParseTreeNode node) {
    int symbolNum;

    if (node==null)
      return false;
    symbolNum=node.symbolNum;
    if (symbolNum==sym.VEJICA)
      return true;
    else
      return false;
  }

  public static String colour (ParseTreeNode node) {
    int symbolNum;

    if (node==null)
      return "FFFFFF";
    symbolNum=node.symbolNum;
    if ((symbolNum==sym.ARRAY) || (symbolNum==sym.BEGIN) || (symbolNum==sym.CASE) || (symbolNum==sym.CONST) || (symbolNum==sym.DO) || (symbolNum==sym.DOWNTO) || (symbolNum==sym.ELSE) || (symbolNum==sym.END) || (symbolNum==sym.FILE) || (symbolNum==sym.FOR)  || (symbolNum==sym.FUNCTION)  || (symbolNum==sym.GOTO)  || (symbolNum==sym.IF)  || (symbolNum==sym.LABEL) || (symbolNum==sym.NIL) || (symbolNum==sym.PROCEDURE) || (symbolNum==sym.PROGRAM)  || (symbolNum==sym.RECORD)  || (symbolNum==sym.REPEAT) || (symbolNum==sym.SET) || (symbolNum==sym.THEN) || (symbolNum==sym.TO) || (symbolNum==sym.TYPE) || (symbolNum==sym.UNTIL) || (symbolNum==sym.VAR) || (symbolNum==sym.WHILE) || (symbolNum==sym.WITH))
      return cKeyword;
    if (symbolNum==sym.IME)
      return cIdentifier;
    if (symbolNum==sym.NIZ)
      return cString;
    if ((symbolNum==sym.ABSOLUTNOSTEVILO) || (symbolNum==sym.NARAVNOSTEVILO)|| (symbolNum==Constants.NODE_NUM_LABEL))
      return cNumber;
    if (symbolNum==Constants.NODE_COMMENT)
      return cComment;
    return cOther;
  }
}