package compiler;

public class Constants {
  public static int NONE=0;
  public static int LIST=10;
  public static int LIST_NON_SEPERATED=11;
  public static int LIST_SEPERATED=12;
  public static int PARAM=20;
  public static int PARAM_BY_VALUE=21;
  public static int PARAM_BY_REFERENCE=22;
  public static int PARAM_FUNCTION=23;
  public static int TYPE=30;
  public static int TYPE_SIMPLE=31;
  public static int TYPE_ENUM=32;
  public static int TYPE_ARRAY=33;
  public static int VAR=40;
  public static int VAR_CONSTANT=41;
  public static int VAR_VARIABLE=42;
  public static int VAR_FUNCTION=43;
  public static int DATA=50;
  public static int DATA_INT=51;
  public static int DATA_DOUBLE=52;
  public static int DATA_CHAR=53;
  public static int DATA_STRING=54;
  public static int SPACES=60;
  public static int SPACES_EQUALS=61;
  public static int SPACES_COLON=61;
  public static int HLINKS=70;
  public static int HLINKS_TO_HERE=71;
  public static int HLINKS_NOT_FROM_HERE=72;
  public static int NODE=10000;
  public static int NODE_PP=10001;
  public static int NODE_COMMENT=10002;
  public static int NODE_NUM_LABEL=10003;
  public static int NODE_COLON_LABEL=10004;

  public static int common (int constant) {
    return 10*((int)(constant/10));
  }
}